var _excluded = ["theme"],
  _excluded2 = ["theme"];
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (-1 !== e.indexOf(n)) continue; t[n] = r[n]; } return t; }
import background from "./background";
import borderMixIn from "./border";
import { getColor } from "../../../theme";
import alignItems from "./alignItems";
var fontColor = function fontColor(_ref) {
  var theme = _ref.theme,
    color = _ref.color;
  if (!color) return "";
  return "color: " + getColor(color)({
    theme: theme
  }) + ";";
};
var clearEmptyLines = function clearEmptyLines(str) {
  return str.replace(/^(?=\n)$|^\s*|\s*$|\n\n+/gm, "");
};
var transforms = {
  border: borderMixIn,
  background: background,
  color: fontColor,
  alignItems: alignItems
};
export var calculateStyles = function calculateStyles(_ref2) {
  var theme = _ref2.theme,
    styles = _objectWithoutPropertiesLoose(_ref2, _excluded);
  var result = "";
  for (var key in styles) {
    if (transforms[key] !== undefined) {
      var transformFuction = transforms[key];
      var transformFuctionResult = transformFuction && typeof transformFuction === "function" ? transformFuction(_extends({
        theme: theme
      }, styles)) : "";
      result = result + transformFuctionResult;
      continue;
    }
    var value = styles[key];
    result = result + (key + ":" + value + ";");
  }
  return result;
};
export var pseudoSelectors = {
  _before: "&::before",
  _after: "&::after",
  _hover: "&:hover, &[data-hover]",
  _active: "&:active, &[data-active]",
  _focus: "&:focus, &[data-focus]",
  _focusWithin: "&:focus-within",
  _visited: "&:visited",
  _empty: "&:empty",
  _even: "&:nth-of-type(even)",
  _odd: "&:nth-of-type(odd)",
  _disabled: "&[disabled], &[aria-disabled=true], &[data-disabled]",
  _checked: "&[aria-checked=true]",
  _mixed: "&[aria-checked=mixed]",
  _selected: "&[aria-selected=true], [data-selected] > &",
  _invalid: "&[aria-invalid=true]",
  _pressed: "&[aria-pressed=true]",
  _readOnly: "&[aria-readonly=true], &[readonly]",
  _first: "&:first-of-type",
  _last: "&:last-of-type",
  _expanded: "&[aria-expanded=true]",
  _grabbed: "&[aria-grabbed=true]",
  _notFirst: "&:not(:first-of-type)",
  _notLast: "&:not(:last-of-type)",
  _groupHover: "[role=group]:hover &",
  _autofill: "&:-webkit-autofill",
  _placeholder: "&::placeholder"
};
export default (function (_ref3) {
  var theme = _ref3.theme,
    props = _objectWithoutPropertiesLoose(_ref3, _excluded2);
  var pseudo = "";
  for (var prop in props) {
    if (prop in pseudoSelectors) {
      var pseudoProp = prop;
      var pseudoStyles = props[pseudoProp];
      var styles = calculateStyles(_extends({
        theme: theme
      }, pseudoStyles));
      pseudo = pseudo + ("\n      " + pseudoSelectors[pseudoProp] + "{ \n        " + styles + " \n      }");
    }
  }
  return clearEmptyLines(pseudo);
});